use std::collections::HashMap;

use crate::tokeniser::tokentype::*;

use super::{expr::ExprBox, typ::TypeBox, Ast};

#[derive(Debug, Clone)]
pub enum Literal {
    Number(Number),
    Ident(Ident),
    String(TString),
    Char(Char),
    Array(Vec<ExprBox>),
    ArrayRepeat {
        typ: Box<TypeBox>,
        count: Box<ExprBox>,
    },
    Struct {
        name: Ident,
        fields: HashMap<Ident, Ast>
    },
}
