use std::collections::HashMap;

use statement::{Enum, Function, Struct, TypeAlias};

pub use crate::tokeniser::tokentype::*;

pub mod expr;
pub mod literal;
pub mod statement;
pub mod typ;

#[derive(Debug, Clone)]
pub struct Program {
    pub ast: expr::Block,
    pub structs: HashMap<Ident, Struct>,
    pub enums: HashMap<Ident, Enum>,
    pub types: HashMap<Ident, TypeAlias>,
    pub functions: HashMap<Ident, Function>,
    pub member_functions: HashMap<Ident, HashMap<Ident, Function>>,
} 

#[derive(Debug, Clone)]
pub enum Ast {
    Expr(expr::ExprBox),
    Statement(statement::StatementBox),
}


