use crate::common::Loc;

use super::{expr::ExprBox, Ident};

#[derive(Debug, Clone)]
pub struct TypeBox {
    inner: Type,
    loc: Loc
}

impl TypeBox {
    pub fn new(loc: &Loc, stat: Type) -> Self {
        Self { loc: loc.clone(), inner: stat }
    }
    pub fn inner(&self) -> &Type {
        &self.inner
    }
    pub fn inner_mut(&mut self) -> &mut Type {
        &mut self.inner
    }
    pub fn loc(&self) -> &Loc {
        &self.loc
    }
}

#[derive(Debug, Clone)]
pub enum Type {
    Ref { 
        inner: Box<Type>,
        mutable: bool,
    },
    Array {
        inner: Box<Type>,
    },
    ArrayRepeat {
        inner: Box<Type>,
        count: ExprBox,
    },
    Owned(Ident),
}
